      subroutine hec_cal_read
c
c read calibration coefficient file
c
      implicit none
c
      include'hec_par.inc'      !shared parameters
      include'hec_cal_coef.inc' !calibration coefficients
      include'hec_datacard.inc' !user datacard
      include'hec_geo.inc'      !geometry correspondence tables
c
      integer i
      integer ic
      real cal(4)
      integer iflg
c
c open input calibration file
c
      open (unit=io_cal(2), file='calib.dat', status='old', err=3)
c
c read version number from top of calibration file
c
      read (io_cal(2), *, err=2, end=4) cal_version
      print *, ' '
      print *, ' *** reading calibration coefficients for version ',
     +         cal_version
c
      ic = 1
      do while (ic .ge. 1 .and. ic .le. i_adc_dim)
        read (io_cal(2), *, err=2, end=4) ic, (cal(i), i=1, 4), iflg
        if (ic .le. i_adc_used .and. ic .gt. 0) then
          if (iflg .eq. 1) then
            do i = 1, 4
              hec_cal_coef(ic, i) = cal(i)
            enddo
          else
            do i = 1, 4
              hec_cal_coef(ic, i) = 0.
            enddo
ccc            if (iflg .eq. 0) then
ccc              print * ,' *** no calibration for channel ', ic
ccc            elseif (iflg .eq. 2) then
ccc              print * ,' *** bad calibration for channel ', ic
ccc            elseif (iflg .gt. 2) then
ccc              print * ,' *** dead channel ', ic
ccc            else
ccc              print * ,' *** problem with calibration for channel ', 
ccc     +        ic, 'with code ', iflg
ccc            endif
          endif
          hec_cal_coef(ic, 5) = iflg
        endif
      enddo
c
 2    continue
      print *, ' *** error reading calibration file'
      close (unit = io_cal(2))
      stop
c
 3    continue
      print *, ' *** error opening calibration file'
      close (unit=io_cal(2))
      stop
c
 4    continue
      print *, ' *** calibration file read ***'
      print *, ' '
      if (run_mode .eq. 1 .and. io_cal(3) .eq. 1) then
        do ic = 1, i_adc_used
          write(*, '(1x, i4, 4(2x, e12.3), 2x, i2)') 
     +    ic, (hec_cal_coef(ic, i), i = 1, 4), nint(hec_cal_coef(ic, 5))
        enddo
      endif
      close (unit=io_cal(2))
c
      end
