      subroutine hec_bad_cells
c
c routine looks at calibration and digital filtering weights to 
c fill bad cell list
c
      implicit none
c
      include'hec_par.inc'      !shared parameters
      include'hec_cal.inc'      !calibrated energies
      include'hec_cal_coef.inc' !calibration coefficients
      include'hec_datacard.inc' !datacard values
      include'hec_dig.inc'      !digital filtering common
      include'hec_dig_sys.inc'  !digital filtering system common
      include'hec_geo.inc'      !geometry correspondence tables
c
c local variables
c
      integer ic,iw,i_t,cflag
      logical cbad, dbad
c
c read digital filtering weights
c
      call hec_dig_read_weights
c
c read calibration coefficients
c
      call vzero(hec_cal_coef, 5*i_adc_dim)
      call hec_cal_read
c
c look for cells with bad digital weights
c      
c
c issue warning for channels with at least one null coefficient for 
c amplitude reconstruction
c
      n_badcells = 0
      do ic = 1, i_adc_used
c
c look for bad (non-existent) digital filtering weights
c
        dbad = .false.
        do i_t = 1, nslice_dig
          do iw = 1, iwmax
            if (dig_amp_par(ic,i_t,iw) .eq. 0.) dbad = .true.
          enddo
        enddo
        if (dbad .and. mk_dig .gt. 0) then
          print *,' *** WARNING no filtering weights for channel  ',ic
        endif        
c
c now look for bad calibration constants
c
        cbad = .false.
        if (hec_cal_coef(ic,5) .ge. 2 .or. hec_cal_coef(ic,5) .eq. 0) 
     +  then
          cbad = .true.
          if (hec_cal_coef(ic,5) .eq. 0) then
            cflag = 1
          elseif (hec_cal_coef(ic,5) .ge. 2) then
            cflag = 2
          endif
        endif
        if (cbad .and. io_cal(1) .gt. 0) then
          print *,' *** WARNING bad/non-existent calibration, channel '
     +             ,ic
        endif
c
c fill array with flags for each bad ic
c
        if (dbad .or. cbad) then
          n_badcells = n_badcells + 1
          i_badcells_ic(n_badcells,1) = ic
          if (cbad) then
            i_badcells_ic(n_badcells,2) = cflag
          else
            i_badcells_ic(n_badcells,2) = 0            
          endif
          if (dbad) then
            i_badcells_ic(n_badcells,3) = 1
          else
            i_badcells_ic(n_badcells,3) = 0
          endif
        endif
      enddo
c
      return
      end



