      subroutine hec_online_clus_axis(hisnum)
c
c adds energy axis to adc cluster histos
c
      implicit none
c
      include'hec_par.inc'          ! shared parameters
      include'hec_datacard.inc'     ! datacard values
      include'hec_his_sys.inc'      ! online histogram ids
c
      integer hisnum
c
c declare variables to store retrieved histogram information
c necessary to add the energy scale axis for clusters
c
      character*80 chtitl
      real nx,xmi,xma,ny,ymi,yma,nwt,loc
      real adc2geve,adc2gevp
      real xlowcm,xhicm,ylowcm,yhicm
c
c declare hbook function
c
      real hmax
      external hmax
c
c initialize conversion factors (adc channel to energy (GeV))
c
      adc2geve = 0.11           ! electrons
      adc2gevp = 0.14           ! pions
c
c add second axis label for cluster energy (GeV)
c
      call hgive(hisnum,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
c
c cluster order would be 15001, 15002, 15003, ...
c cluster with < 10 cells -- electron-type cluster
c
      if(his_clus_cell_array(1,hisnum-15000).lt.10) then
        call igaxis(xmi,xma,1.11*hmax(hisnum),1.11*hmax(hisnum),
     +    adc2geve*xmi,adc2geve*xma,510,'-=BPDHS')
      else
c
c cluster with >= 10 cells -- pion-type clusters
c
        call igaxis(xmi,xma,1.11*hmax(hisnum),1.11*hmax(hisnum),
     +    adc2gevp*xmi,adc2gevp*xma,510,'-=BPDHS')
      endif
      call hplgiv(xlowcm,ylowcm,xhicm,yhicm)
      call hplsof(xhicm,yhicm,'GeV',0.35,0.,0.,-1.)
c
      return
      end
      
